var _a;
import { BinaryCoStream, CoMap, val, subscriptionsScopes, } from "../../internal.js";
export class ImageDefinition extends CoMap {
    constructor() {
        super(...arguments);
        this.originalSize = val.json();
        this.placeholderDataURL = val.string;
        this[_a] = val.ref(() => BinaryCoStream);
    }
    get highestResAvailable() {
        if (!subscriptionsScopes.get(this)) {
            console.warn("highestResAvailable() only makes sense when used within a subscription.");
        }
        const resolutions = Object.keys(this).filter((key) => key.match(/^\d+x\d+$/));
        resolutions.sort((a, b) => {
            const aWidth = Number(a.split("x")[0]);
            const bWidth = Number(b.split("x")[0]);
            return aWidth - bWidth;
        });
        let highestAvailableResolution;
        for (const resolution of resolutions) {
            if (this[resolution] && this[resolution]?.getChunks()) {
                highestAvailableResolution = resolution;
            }
            else {
                return (highestAvailableResolution && {
                    res: highestAvailableResolution,
                    stream: this[highestAvailableResolution],
                });
            }
        }
        return (highestAvailableResolution && {
            res: highestAvailableResolution,
            stream: this[highestAvailableResolution],
        });
    }
}
_a = val.items;
//# sourceMappingURL=imageDef.js.map